unit u_prog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TdlgProg = class(TForm)
    BitBtn3: TBitBtn;
    lbFile: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    lbFilesCur: TLabel;
    pbFiles: TProgressBar;
    lbFilesTot: TLabel;
    lbBytesCur: TLabel;
    pbBytes: TProgressBar;
    lbBytesTot: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure WMUSER8(var msg: TMessage); message WM_USER + 8;
  public
    { Public declarations }
    procedure BarsUpdate(const BC, BP, FC, FP: Int64; const aName: string);
  end;

var
  dlgProg: TdlgProg;

implementation

uses u_Main, u_str;

{$R *.DFM}

procedure TdlgProg.FormCreate(Sender: TObject);
begin
  Caption := Format(rspWork, [defCap]);
end;

procedure TdlgProg.FormShow(Sender: TObject);
begin
  FormPosLoad(self);
  PostMessage(Handle, WM_USER + 8, 77, 99);
end;

procedure TdlgProg.BitBtn3Click(Sender: TObject);
begin
  fEscape := True;
  Close;
end;

procedure TdlgProg.WMUSER8(var msg: TMessage);
begin
  if (msg.lParam = 99) and (msg.WParam = 77) then
  begin
    Update;
    Application.ProcessMessages;
    fmMain.DoCopying;
    Close;
  end;
end;

procedure TdlgProg.BarsUpdate(const BC, BP, FC, FP: Int64; const aName: string);
begin
  lbBytesCur.Caption := Readable(BC);
  lbFilesCur.Caption := Readable(FC);
  pbBytes.Position := BP;
  pbFiles.Position := FP;
  lbFile.Caption := aName;
  GroupBox1.Caption := Format(rspFiles, [FP]);
  GroupBox2.Caption := Format(rspBytes, [BP]);
end;

procedure TdlgProg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FormPosSave(self);
end;

end.
